//Une partie.
package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;


	public class Game extends Sprite //On doit le faire extends sprite pour pouvoir bnficier des listeners.
	{
		public var Terrain:Land;
		public var Termine:Boolean=false;
		public var Gagnant:*;
		public var TraceInfo:String="";
		public var NumeroNiveau:int=-1;
		public var CallBack:Function;

		private static const SHORT:int=0;
		private static const CUT:int=1;



		private static const HUMAN:int=0;
		private static const COMPUTER:int=1;
		private static const INTERNET:int=2;


		private var Short:*;
		private var Cut:*;
		private var Joueur_Actuel:int=-1;
		private  var Tour:Array;



		public function Game(FirstPlayer:int,Short_Type:int,Cut_Type:int,Datas:String,Passif:Boolean=false)
		{
			//L'initialisation du jeu. Rien de bien compliqu...
			this.Terrain=new Land(Datas,this);
			this.Terrain.Texte="INITIALISATION..."
			switch (Short_Type)
			{
			case HUMAN: Short=new Human(this,SHORT); break;
			case COMPUTER: Short=new AI(this,SHORT); break;
			case INTERNET: Short=new OnlinePlayer(this,SHORT); break;
			}
			switch (Cut_Type)
			{
			case HUMAN: Cut=new Human(this,CUT); break;
			case COMPUTER: Cut=new AI(this,CUT); break;
			case INTERNET: Cut=new OnlinePlayer(this,CUT); break;
			}

			this.Tour=new Array(Short,Cut);
			if(FirstPlayer==CUT)
				this.Tour.reverse();

			if(!Passif)
			{
				Short.Initialiser(Fin_Initialisation);
				Cut.Initialiser(Fin_Initialisation);//Attendre que les deux joueurs soient prts.
			}
			else
			{
				this.Terrain.StopBackGround();
			}

		}

		public function Fin_Initialisation():void
		{
			if(Short.Pret && Cut.Pret)
			{
					this.Terrain.graphics.clear();
					Lancer_tour();
			}
		}

		private function Lancer_tour():void
		{
			this.removeEventListener(Event.ENTER_FRAME,TestFinTour);
			Joueur_Actuel = (Joueur_Actuel+1)%2;
			this.Tour[Joueur_Actuel].Jouer();
			this.addEventListener(Event.ENTER_FRAME,TestFinTour);

			if(this.Tour[Joueur_Actuel].Joueur==SHORT)
				this.Terrain.Texte="Tour actuel : <strong>Paintre</strong>";
			else
				this.Terrain.Texte="Tour actuel : <strong>Couhpeur</strong>";
		}

		private function TestFinTour(e:Event):void
		{
			if(this.Tour[Joueur_Actuel].Tour_Termine)
			{
				this.Tour[Joueur_Actuel].Fin_Tour();
				this.TraceInfo=this.Tour[Joueur_Actuel].TraceInfo;
				if(TestVictoire())
				{
					this.CallBack.call(this);
					if(this.Tour[Joueur_Actuel].Joueur==SHORT)
						this.Terrain.Texte="Fin de la partie, gagnant : <strong>Paintre</strong>";
					else
						this.Terrain.Texte="Fin de la partie, gagnant : <strong>Couhpeur</strong>";
					this.removeEventListener(Event.ENTER_FRAME,TestFinTour);
				}
				else
					Lancer_tour();
			}
		}

		private function TestVictoire():Boolean
		{
			var Resultat:Boolean=false;
			var CorrectPath:ArrayPlus=new ArrayPlus();
			//Teste si le jeu est termin.
			//Le jeu est dterministe, c'est  dire qu'il y a forcment un gagnant(il ne peut pas y avoir d'galit).

			//Teste si Short a gagn : (I.e il existe un chemin entirement color)
			if(TesteShort())
			{
				this.Gagnant=Short;
				return true;
			}

			//Teste si Cut a gagn : (I.e il n'existe aucun chemin entre le dpart et l'arive)
			if(TesteCut())
			{
				this.Gagnant=Cut;
				return true;
			}

			return false;

			//Fin de la fonction....
		}

		private function TesteShort():Boolean
		{//true si short a gagn
			var CheminExiste:Boolean=false;
			function Short_PathFinde(Node:Noeud,Path:ArrayPlus):void
			{
				//Si le noeud examin est le noeud final, on a gagn :)
				if(Node==Terrain.EndNode)
					CheminExiste=true;

				if(CheminExiste!=true)
				{//Sinon, on regarde chaque arete du noeud et on teste rcursivement.d
					for each(var Arete:Arc in Node.Liens)
					{
						if(Arete.PlayedByShort && !Path.Contains(Arete))
						{
							var CopiePath:ArrayPlus=Path.Clone();
							CopiePath.push(Arete);
							if(Arete.Extremites[0]==Node)
								Short_PathFinde(Arete.Extremites[1],CopiePath)
							else
								Short_PathFinde(Arete.Extremites[0],CopiePath)
						}
					}
				}
			}
			Short_PathFinde(this.Terrain.StartNode,new ArrayPlus());
			return CheminExiste;
		}
		private function TesteCut():Boolean
		{//true si cut a gagn
			var CheminExiste:Boolean=false;
			function Cut_PathFinde(Node:Noeud,Path:ArrayPlus):void
			{
				//Si le noeud examin est le noeud final, on a pas encore gagn :) (il existe un chemin entre le dpart et l'arrive)
				if(Node==Terrain.EndNode)
					CheminExiste=true;

				if(CheminExiste==false)
				{//Sinon, on regarde chaque arete du noeud et on teste rcursivement.
					for each(var Arete:Arc in Node.Liens)
					{
						if(!Path.Contains(Arete))
						{
							var CopiePath:ArrayPlus=Path.Clone();
							CopiePath.push(Arete);
							if(Arete.Extremites[0]==Node)
								Cut_PathFinde(Arete.Extremites[1],CopiePath)
							else
								Cut_PathFinde(Arete.Extremites[0],CopiePath)
						}
					}
				}
			}
			Cut_PathFinde(this.Terrain.StartNode,new ArrayPlus());
			return !CheminExiste
		}
	}
}